import { FunctionsErrorCode, HttpsCallable, HttpsCallableOptions, IFunctions } from './common';
import { FirebaseApp } from '@nativescript/firebase-core';
export declare class HttpsError extends Error {
    readonly code: FunctionsErrorCode;
    readonly details?: any;
    readonly native: any;
    constructor(code: FunctionsErrorCode, message: string, details?: any, native?: any);
}
export declare class Functions implements IFunctions {
    _native: com.google.firebase.functions.FirebaseFunctions;
    _app: FirebaseApp;
    constructor(app?: FirebaseApp);
    httpsCallable(name: string, options?: HttpsCallableOptions): HttpsCallable;
    useEmulator(host: string, port: number): void;
    get native(): com.google.firebase.functions.FirebaseFunctions;
    get ios(): com.google.firebase.functions.FirebaseFunctions;
    useFunctionsEmulatorOrigin(origin: string): void;
    get app(): FirebaseApp;
}
